#include "protheus.ch"
#Include "MSOLE.CH"
#include "rwmake.ch"          
#INCLUDE "topconn.ch"
/*  


ͻ
 Programa  ORCPC     Autor Manoel Carlos Junior Data   24-04-15   
͹
Descricao  Imprime um OS de peas  solicitada em um arquivo           
           arquivo word.                                              
͹
Modulo    | SIGATEC  | USO | Especifico do SIGATEC                     
ͼ


*/

User Function ORCPC()

Local cPerg    := PadR("ORCPC", Len(SX1->X1_GRUPO))

CriaSX1(cPerg)
Pergunte(cPerg, .T.)

@ 96,012 TO 250,410 DIALOG oDlg TITLE OemToAnsi ("Integracao com MS-Word") 
@ 08,005 TO 048,200
@ 18,010 SAY OemToAnsi("Esta rotina ira imprimir um Oramento tcnico conforme os parametros digitados.")

@ 56,130 BMPBUTTON TYPE 1 ACTION Processa( { |lEnd| WordImp()}, "Processando...", "Oramento de Servio...")
@ 56,160 BMPBUTTON TYPE 2 ACTION Close(oDlg)

ACTIVATE DIALOG oDlg CENTERED

Return()


Static Function WordImp()
//dados da EMPRESA
Local wcNomEmp	:= SM0->M0_NOMECOM
Local wcCgCEmp	:= transform(SM0->M0_CGC,"@R 99.999.999/9999-99") 
Local wcIncEmp	:= SM0->M0_INSC               

Local wcEndEmp	:= SM0->M0_ENDENT
Local wcBaiEmp	:= SM0->M0_BAIRENT
Local wcCidEmp	:= SM0->M0_CIDENT
Local wcEstEmp	:= SM0->M0_ESTENT
Local wcCepEmp	:= SM0->M0_CEPENT
Local wcTelEmp	:= SM0->M0_TEL
Local wcFaxEmp	:= SM0->M0_FAX

//dados do Cabealho
Local wcOr    	 := ""
Local WcEmissao := ""
Local wcCliente := ""
Local wcLoja    := ""
Local wcCNome   := ""
Local wcLuso    := ""
Local wcDLuso   := ""

//DADOS DO ORCAMENTO    
Local wcItem   := {}
Local wcCodigo := {}
Local wcDescri := {}
Local _aItens  := {}

Local wcQtd    := {}
Local wcPcun   := {}
Local wcPcTot  := {}
Local wcVTot   := 0
local ncontSv           := 0 
//Final do orcamento

Local wcCot    := ""
Local wcCpg    := ""
Local wcValid  := ""

//dados gerais

Local nCont		:= 0 
Local nContI	:= 0 
Local nAuxTot	:= 0   
Local cPerg    := "ORCPC" 
Local cArq     := ""
Local cArqDot  := "ORCPC.dot" // Nome do Arquivo MODELO do Word
Local cPathDot := Alltrim(GetMv("MV_XPATDOT"))+ cArqDot // Path do arquivo modelo word no servidor
Private cPathEst
Private	hWord
Close(oDlg)

//--------------------------------------------------------------------------------  

//Criando Query

cQuery := " SELECT CJ_NUM, CJ_EMISSAO, CJ_FILIAL, CJ_CLIENTE, CJ_LOJA, A1_NREDUZ,CJ_XLOCAL, CJ_XNLOCAL, CK_ITEM,  "+CRLF
cQuery += " CK_PRODUTO, A1_NREDUZ, CJ_XLOCAL, CK_ITEM, CK_PRODUTO, CK_DESCRI, CK_QTDVEN, CK_PRCVEN, "+CRLF
cQuery += " CK_VALOR, CJ_COTCLI, CJ_CONDPAG, CJ_VALIDA "+CRLF 
cQuery += " FROM SCJ010 SCJ LEFT JOIN SA1010 ON A1_COD  = CJ_CLIENTE AND A1_LOJA = CJ_LOJA "+CRLF 
cQuery += " LEFT JOIN SCK010 ON CK_FILIAL =  CJ_FILIAL "+CRLF 
cQuery += " AND CK_LOJA   =  CJ_LOJA "+CRLF 
cQuery += " AND CK_NUM    =  CJ_NUM  "+CRLF
cQuery += " WHERE SCJ.D_E_L_E_T_ <>'*' "+CRLF
cQuery += " AND SA1010.D_E_L_E_T_ <>'*' "+CRLF
cQuery += " AND SCK010.D_E_L_E_T_ <>'*' "+CRLF
cQuery += " AND CJ_FILIAL = '" + MV_PAR01 + "'"+CRLF
cQuery += " AND CJ_NUM = '" + MV_PAR02 + "'"+CRLF
cQuery += " AND CJ_EMISSAO >= '" + DtoS(MV_PAR03) + "'"+CRLF
cQuery += " AND CJ_EMISSAO <= '" + DtoS(MV_PAR04) + "'"+CRLF
cQuery += " ORDER BY CJ_NUM, CJ_EMISSAO "+CRLF

MEMOWRITE("SQL.SQL",cQuery)

If Select("TRB") > 0
	dbSelectArea("TRB")
	TRB->(dbCloseArea())
EndIf   

cQuery := ChangeQuery(cQuery) 


DbUseArea(.T.,'TOPCONN',TCGENQRY(,,cQuery) ,"TRB",.T.,.T.) 



//Cabecalho Relatrio Tcnico
dbSelectArea("TRB")
If TRB->(Eof()) 
	Aviso("Impresso Relatrio Tcnico ","No existe Relatrio Tcnico  a ser impresso!",{"OK"})
	Return
EndIf  
While !TRB->(EOF())
	nCont ++
	TRB->(DBSKIP())
EndDo
ProcRegua(nCont)
TRB->(DBGOTOP())

IncProc("Gerando Relatrio Tcnico...")
 //--------------DADOS DO CABECALHO -----------------------	 

wcOr    	 := TRB-> CJ_NUM 
WcEmissao := stod(TRB-> CJ_EMISSAO)
wcCliente := TRB-> CJ_CLIENTE  
wcLoja    := TRB-> CJ_LOJA  
wcCNome   := TRB-> A1_NREDUZ
wcLuso    := TRB-> CJ_XLOCAL
wcDLuso   := TRB-> CJ_XNLOCAL

        
//-------- email -------------------------
IF  MV_PAR01 = "0101"                               //por enquanto s SP e PE tem ASTEC
    wcEmail  = "asstec.sp@samtronic.com.br"
    else
    wcEmail  = "asstec.pe@samtronic.com.br"
ENDIF    

//-------------------------------- FINAL DO ORCAMENTO ---------------------------------------------------
wcCot    := TRB -> CJ_COTCLI
wcCpg    := TRB -> CJ_CONDPAG
wcValid  := stod(TRB -> CJ_VALIDA)
//-------------- DESCRICAO DO OCAMENTO  --------------
While !TRB->(EOF())   

AAdd(wcItem,TRB-> CK_ITEM)      
AAdd(wcCodigo,TRB-> CK_PRODUTO)
AAdd(wcDescri,TRB-> CK_DESCRI)
AAdd(wcQtd,TRB-> CK_QTDVEN)
AAdd(wcPcun,TRB-> CK_PRCVEN)
AAdd(wcPcTot,TRB-> CK_VALOR)
wcVTot += TRB-> CK_VALOR 
nContI++
TRB->(DBSKIP())
//aAdd(wcItem,TRB-> CK_ITEM)  
//aAdd(wcCodigo,TRB-> CK_PRODUTO )
//nContI++
//wcCodigo := TRB-> CK_PRODUTO 
//wcDescri := TRB-> CK_DESCRI  +chr(13)+chr(10)
//wcQtd    := TRB-> CK_QTDVEN  +chr(13)+chr(10) 
//wcPcun   := TRB-> CK_PRCVEN  +chr(13)+chr(10)
//wcPcTot  := TRB-> CK_VALOR   +chr(13)+chr(10)
//wcVTot   := ""
enddo 




//Conecta ao word
hWord	:= OLE_CreateLink()
OLE_SetProperty ( hWord, oleWdVisible, .T.)
//OLE_NewFile(hWord,cPathDot+cArqDot)
	//Ŀ
	// Seu Documento Criado no Word A extensao do documento tem que ser .DOT 
	//
	 	nPos := RAT("\",cArqDot)
			
		If nPos > 0
			cArq:= Substr(cArqDot,nPos+1)
		Else
			cArq:= "\"+cArqDot
		Endif
  		
	//	   Local HandleWord
	 	cPathEst := Alltrim(GetMv("MV_DIREST")) 		// PATH DO ARQUIVO A SER ARMAZENADO NA ESTACAO DE TRABALHO
		
	  MontaDir(cPathEst)
		
	// Caso encontre arquivo ja gerado na estacao
	// com o mesmo nome apaga primeiramente antes de gerar a nova impressao
		If File( cPathEst + cArq )
			Ferase( cPathEst + cArq)
		EndIf             
		
		CpyS2T(cPathDot, cPathEst ,.T.) 	// Copia do Server para o Remote, eh necessario
	// para que o wordview e o proprio word possam preparar o arquivo para impressao e
	// ou visualizacao .... copia o DOT que esta no ROOTPATH Protheus para o PATH da
	// estacao , por exemplo C:\WORDTMP
		
	//Ŀ
	// Gerando novo documento do Word na estacao 
	//
	  	OLE_NewFile( hWord, cPathEst + cArq)
		
	//Conecta ao word
	 	BeginMsOle()                         
	
	//linhas na parte variavel
	//empresa  	
	OLE_SetDocumentVar(hWord, 'Prt_emp', ALLTRIM(wcNomEmp))
	OLE_SetDocumentVar(hWord, 'Prt_end', ALLTRIM(wcEndEmp))		
	OLE_SetDocumentVar(hWord, 'Prt_bairro', ALLTRIM(wcBaiEmp))
	OLE_SetDocumentVar(hWord, 'Prt_tel', ALLTRIM(wcTelEmp))
	OLE_SetDocumentVar(hWord, 'Prt_cidade', ALLTRIM(wcCidEmp))
	OLE_SetDocumentVar(hWord, 'Prt_cep', ALLTRIM(wcCepEmp))		
	OLE_SetDocumentVar(hWord, 'Prt_fax', ALLTRIM(wcFaxEmp))		                            
	OLE_SetDocumentVar(hWord, 'Prt_est', alltrim(wcEstEmp))
	OLE_SetDocumentVar(hWord, 'Prt_email', alltrim(wcEmail))			
   OLE_SetDocumentVar(hWord, 'Prt_nroitens',str(Len(wcItem)))

	//--------------DADOS DO CABECALHO -----------------------	 

	OLE_SetDocumentVar(hWord, 'Prt_Orc', wcOr)
	OLE_SetDocumentVar(hWord, 'Prt_Data',WcEmissao)		
	OLE_SetDocumentVar(hWord, 'Prt_Cli',wcCliente)			
	OLE_SetDocumentVar(hWord, 'Prt_Lj',wcLoja)
  	OLE_SetDocumentVar(hWord, 'Prt_Nome',wcCNome)
  	OLE_SetDocumentVar(hWord, 'Prt_Luso',wcLuso)
	OLE_SetDocumentVar(hWord, 'Prt_DLuso',wcDLuso)

 //---------------DADOS DO ORCAMENTO-------------------------    
   for I := 1 to Len(wcItem)
   
   OLE_SetDocumentVar(hWord, 'Prt_Item'+AllTrim(Str(I)),wcItem[I]) 
  	OLE_SetDocumentVar(hWord, 'Prt_Codigo'+AllTrim(Str(I)),wcCodigo[I])		
	OLE_SetDocumentVar(hWord, 'Prt_Descri'+AllTrim(Str(I)),wcDescri[I])			
	OLE_SetDocumentVar(hWord, 'Prt_Qtd'+AllTrim(Str(I)),ALLTRIM(transform(wcQtd[I],"@E 9999")))
  	OLE_SetDocumentVar(hWord, 'Prt_Pcun'+AllTrim(Str(I)),ALLTRIM(transform(wcPcun[I],"@E 99,999,999.99")))
  	OLE_SetDocumentVar(hWord, 'Prt_PcTot'+AllTrim(Str(I)),ALLTRIM(transform(wcPcTot[I],"@E 99,999,999.99")))
	next 	
  	
  	OLE_ExecuteMacro(hWord,"tabitens")
   OLE_SetDocumentVar(hWord, 'Prt_VTot',Alltrim(transform(wcVTot,"@E 99,999,999.99"))) 
  	
  //---------------FINAL DO ORCAMENTO -----------------------
  
   OLE_SetDocumentVar(hWord, 'Prt_Cot', wcCot)	
   OLE_SetDocumentVar(hWord, 'Prt_Cpg', wcCpg)	
   OLE_SetDocumentVar(hWord, 'Prt_Valid', wcValid) 	


//Montagem das variaveis do cabecalho		
   OLE_SetDocumentVar(hWord, 'Prt_Data',WcEmissao)

	OLE_UpdateFields(hWord) 
	EndMsOle()

	TRB->(DBSKIP()) 
	IncProc("Gerando Oramento de Servico...")

		
//Ŀ
// Atualizando as variaveis do documento do Word                         
//

OLE_UpdateFields(hWord)
If MsgYesNo("Imprime o Documento ?")
	Ole_PrintFile(hWord,"ALL",,,1)
EndIf
		
If MsgYesNo("Fecha o Word e Corta o Link ?")
	OLE_CloseFile( hWord )
	OLE_CloseLink( hWord )
Endif	
Return()  

//Ŀ
// Criando Pergunta                                                      
//

Static function CriaSX1(cPerg)

//Ŀ
//Definio dos arrays que sero utilizados para criao das dicas das 
//perguntas.                                                           
//
Local cPerg    := PadR("ORCPC", Len(SX1->X1_GRUPO))
//Ŀ
//Definio dos arrays que sero utilizados para criao das dicas das |
//|perguntas.                                                           
//
Local aHelp := {}
//Ŀ
// MV_PAR01 - Carregando arrays de dicas. Note que cada lingua que um array prprio. 
//
AAdd(aHelp, {{"Digite a n da filial"            }, {""}, {""}})
AAdd(aHelp, {{"Digite o n do orcamento "        }, {""}, {""}})
AAdd(aHelp, {{"Data Inicial "            }, {""}, {""}})
AAdd(aHelp, {{"Data Final"               }, {""}, {""}})
                

//Ŀ
//Agora chamamos a funo para criar as peruntas.                        
//Lembrando que a funo  executada uma vez pra cada pergunta do grupo. 
//
PutSx1( cPerg, "01","Filial " ,"","","mv_ch1","C",4,0,0,"G","","","","","mv_Par01","","","","","","","","","","","","","","","","",aHelp[1,1],aHelp[1,2],aHelp[1,3],"")
PutSx1( cPerg, "02","Oramento" ,"","","mv_ch2","C",6,0,0,"G","","","","","mv_Par02","","","","","","","","","","","","","","","","",aHelp[2,1],aHelp[2,2],aHelp[2,3],"")
PutSx1( cPerg, "03","Emitido em " ,"","","mv_ch3","D",8,0,0,"G","","","","","mv_Par03","","","","","","","","","","","","","","","","",aHelp[3,1],aHelp[3,2],aHelp[3,3],"")
PutSx1( cPerg, "04","At " ,"","","mv_ch4","D",8,0,0,"G","","","","","mv_Par04","","","","","","","","","","","","","","","","",aHelp[4,1],aHelp[4,2],aHelp[4,3],"")
Return
